/*
 *	<< Calculate Imbeddings of Discrete Series into Principal Series >>
 *
 *		    February 28, 1988, Written by Toshio OSHIMA
 *
 *
 *	This program can be compiled by  Lattice C Ver 3.*  for MS-DOS.
 *	or Turbo C 1.5/2.0 or Borland C.
 *
 *	It can also be compiled by  gcc/standard C  in UNIX
 *    In this case change as follows
 *
 *      #define MS_DOS   NO
 *
 *
 *	If this program is used by a terminal with a different console
 *    control sequence from PC-9801 operating in MS-DOS, please change the
 *    following definitions to fit your terminal.
 *
 *	#define	CON_CLR   "\033*"		Clear screen
 *	#define	CON_REV	  "\033[7;36m"		Highlight or reverse mode
 *	#define	CON_NORM  "\033[m"		Return to normal mode
 */

/*

Ver 1.0: Feb. 11, 1988
	Original  for SU(p,q)
	++-+-+ : 371 sec, Hit 19472 -> 35

Ver 1.1: Feb. 13, 1988
	Check the following duplications to speed up ( p-q > 1 or q-p > 1),
	which correspond to  SL(2,C).
		..pq..   = ..qp..
		..p/q..  = ../qp..
		../p/q.. = ../q/p..
	++-+-+ :  28 sec, Hit   558 ->  35
	+-+-+- : 596 sec, Hit 11854 -> 135

Ver 1.2: Feb. 14, 1988
	Check the following duplications to speed up ( p-q = 1 or q-p = 1).
	which correspond to  SU(2,1) or SL(3,R).
		..pqp..    = ..qpq..
		../qpq..   = ..pq/p..
		../q/p/q.. = ../p/q/p..
	++-+-+ :  20 sec, Hit :  331 ->  35
	+-+-+- : 335 sec, Hit : 5471 -> 135

Ver 1.3: Feb. 15, 1988
	Check the following duplications to speed up (+-+ or -+-).
		../qpq..  = ../pqp..
	++-+-+ :  18 sec, Hit :  273 ->  35
	+-+-+- : 308 sec, Hit : 4556 -> 135

Ver 1.4: Feb. 17, 1988
	Omit vo[];
	++-+-+ :  16.6 sec
	+-+-+- : 276   sec

Ver 2.0: Feb. 21, 1988
	Support all Classical Cases with Discrete Series:
		SU(m,n), SO(2m,2n+1), Sp(m,n), SO(2m,2n+1), SO*(2n), Sp(n,R)

Ver 2.1: Feb. 23, 1988
	Support all Harish-Chandra modules (not only discrete series):

	PC9801 VM   V30   10M Heltz	++-+-+: 18.3 sec	+-+-+-: 323 sec
	       VX   80286  8M Heltz	++-+-+: 10.0 sec	+-+-+-: 183 sec
	       VX21 80286 10M Heltz ++-+-+:  8.0 sec    +-+-+-: 143 sec
	VAX 86000 Computer Center, University of Tokyo 	+-+-+-:  50 sec

Ver 2.2: Feb. 26, 1988
	Fixed a bug for SO(2m,2n) & SO*(2n) concerning the improvement
	 in Ver 1.1

Ver 2.3: Feb. 28, 1988
	Support user interface for any Harish-Chandra module for classical
	cases.

Ver 2.4: Mar. 20, 1988
	PC-9801 VX21 80286 10M Heltz, TURBOC V 1.5 -dOZ	+-+-+-: 129 sec

Ver 2.5: Apr.  2, 1988
	Fixed a bug for SO(2m,2n) & SO*(2n) for case 15 - 18:

Ver 2.6: Apr.  8, 1988
	Automatic check of an internal error (Last stage of pair) and
	some conjecture for index.
	Option for showing Bruhat ordering.

Ver 2.7: Apr. 14, 1988
	Define an oriented Bruhat ordering.

Ver 2.8: July 15, 1988
	Fixed a bug for CKPQ3


    PC-9801 RA21 80386 20M Helz, TURBOC C     2.0   -dOZ    +-+-+-:  67.2 sec
    PC-9801 RA21 80386 20M Helz, TURBOC C++   1.1   -dOZ    +-+-+-:  62.6 sec
    ----      Cx486DLC 20M Helz, TURBOC C++   1.1   -dOZ    +-+-+-:  31.1 sec
    ----      Cx486DLC 20M Helz, Borland C++  3.00  -dGO2   +-+-+-:  29.9 sec
    ----      Cx486DLC 40M Helz, Borland C++  3.00  -dGO2   +-+-+-:  18.3 sec
    PC-9801 RA21 80386 20M Helz, EXE386 + gcc 1.37.1  -O    +-+-+-:  53.8 sec
    PC-9801 RA21 80386 20M Helz, GO32   + gcc 1.39    -O    +-+-+-:  50.2 sec
    ----      Cx486DLC 20M Helz, GO32   + gcc 1.39    -O    +-+-+-:  30.3 sec
    ----      Cx486DLC 20M Helz, GO32   + gcc 2.2.2   -O    +-+-+-:  29.5 sec
    ----      Cx486DLC 40M Helz, GO32   + gcc 2.2.2   -O    +-+-+-:  20.2 sec
    Dynabook SS425 80486SLC 25M, Borland C++  3.1  -dGO2    +-+-+-:  17.3 sec
    PC-9821 C9W  80486 66M Helz, Borland C++  3.1  -dGO2    +-+-+-:   6.8 sec
                                                           +-+-+--: 119.7 sec
    JS20/M50  superSPARC 50M Helz, gcc               -O2    +-+-+-:   2.3 sec
                                                           +-+-+--:  23.5 sec
Ver 2.9: Jan 27, 1995
        Fixed a bug for superSPARC with gcc

    Penitium 133M Helz                                     +-+-+-+: 454.0 sec

    SOTEC Winbook Quattro90  Pentium 90M Helz              +-+-+--:  27.8 sec

    Pentium MMX       200M Helz, Borland C++  3.1  -dGO2    +-+-+-:   1.? sec
                                                           +-+-+--:  12.0 sec
                                                           +-+-+-+: 294.8 sec

    PentiumII(ECC 512K) 400M Helz                          +-+-+-+: 168.3 sec

    FMV DESKPOWER CVIII305 K6-2 300M Helz                  +-+-+-+: 163.8 sec

    SONY VAIO PCG-N505SX Pentium MMX 300M Helz             +-+-+-+: 197.5 sec

    SONY VAIO PCG-N505EL Celeron 300M Helz                 +-+-+--:   7.2 sec
                                                           +-+-+-+: 185.0 sec

    Pentium III (Copermine) 750M Helz                      +-+-+-+:  68.2 sec

   Represent K_c orbits in the Flag Manifold as follows.

   O : 0
   + : 1
   - : 2
   a, b, c, ...    : 3, 4, 5, ...
   a', b', c', ... : SHIFT+3, SHIFT+4, SHIFT+5, ...

   a', b', c', ... : A, B, C, ...

  ++ab-ba (= ++ba-ab) = 1134243

 */

#include	<stdio.h>

#define		YES		1
#define		NO		0

#define		MS_DOS		NO

#define		CON_CLR   	"\033*"		/* Clear screen */
#define		CON_REV	  	"\033[7;36m"	/* Highlight or reverse mode */
#define		CON_NORM  	"\033[m"	/* Return to normal mode */

#define		DEBUG		0

#define		CKPQ		YES	/* Check ..pq.. = ..qp.. (Ver 1.1) */
#define		CKPQ2		YES	/* Check ..pqp.. = ..qpq.. (Ver 1.2) */
#define		CKPQ3		YES	/* Check /qpq = /pqp (Ver 1.3) +-+  */

#define		TEST		YES	/* For the use of debugging */

#define		MAX_SIZZ	15	/* Maximal rank of the group */
#define		MAX_STEP	126	/* Maximal step from compact orbits */
#define		MAX_W		2000	/* Max of step*rank */
#define		MAX_NEW		20000	/* Use for imbeddings for each orbit */

/* Remark: (rank + 1)*(# of imbeddings of one discrete series) < MAX_NEW    */
/*   Should be  8*MAX_STEP > (2*MAX_SIZZ + 1)^2	 */
/*   Free memory requires more than (4*MAX_W + 3*MAX_STEP + MAX_NEW) bytes */

#define		MAX_WIDTH	80	/* width for output formatting */


#define		SHIFT		128	/* half of 8 bits >= MAX_STEP + 2 */

#define		TYPE		7	/* Use for 'type' */
#define		cC		0x02
#define		dD		0x04
#define		SO		0x08
#define		atoA		0x10
#define		plsto0		0x20
#define		aAto00		0x40
#define		NO_DISC		0x80

#define		SU21		0
#define		SO21		1
#define		Sp21		2
#define		SpnR		3
#define		SO22		4
#define		SO2n		5

#define		MAXONLY		0x0110		/* Use for 'f_out' */
#define		ALLOUT		0x0008
#define		GIVEN		0x0020
#define		NO_TTL		0x0040
#define		NO_LF		0x0080
#define		CODIM		0x0100
#define		HC_MOD		0x0200
#define		NO_CONIN	0x0400
#define		OUT_DUP		0x0800
#define		DBG		0x1000
#define		DBG1		0x2000
#define		OUT_HIT		0x4000
#define		SORT		0x8000

#define		ORDER		0x0001
#define		ORIENT		0x0002

int		sizz;			/* size of symmetric group */
int		siz1;			/* = sizz if 'a' type else sizz+1 */
int		siz2;			/* = 2*sizz+1 */
int		resdif;			/* restriction of difference of +- */
int		count;			/* # of imbeddings */
int		level_end;		/* codimension of compact orbits */
int		level_v;		/* current step to the open orbit */
int		level_max;		/* maximal level */
int		step[MAX_STEP];		/* each step: simple reflection
					   -k: k-th differential operator
					    k: k-th integral operator
					 */

unsigned int		f_out;			/* flag for output
					   b_0: output pairs separately
					   b_1: output +-
					   b_2: output reduced expression
					   b_3: output all elements
					   b_4: output only maximal imbeddings
					   b_5: output for a given one
					   b_6: output no title
					   b_7: output linefeed
					   b_8: output only codimension
					   b_9: not initialize pairo[]
					   b_10: stdin in not console
					   b_11: output duplication
					   b_12: output all informations
					   b_13: output more informations
					 */
unsigned int		f_out2;		/* extra flag for output
					   b_0:	output duplications
					 */

int		type;			/* type of orbits
					   (b_2,b_1,b_0):
						0: SU(m,n)	a
						1: SO(2m,2n+1)	b
						2: Sp(m,n)	c
						3: Sp(n,R)	C
						4: SO(2m,2n)	d
						5: SO*(2n)	D
					   b_3: SO(2m+1,2n)?
					   b_4:	(a)  ->  (A)
					   b_5: (+)  ->  (0)
					   b_6: (aA) ->  (00)
					   b_7: No discrete series
					 */
int		type0;			/* = type & TYPE */

int		codim;			/* Use for the codimension */
unsigned int	dupl;			/* counter for duplication */
unsigned char	wo[MAX_W];		/* Weyl group for intertwining op. */
unsigned char	orbo[MAX_W];		/* current orbit */
int		pairz[MAX_SIZZ+1];	/* last pairs */
int		pairo[MAX_W];		/* informations for pairs */
unsigned char	orbc[MAX_STEP];		/* for elements of orbo[] */
unsigned char	neww[MAX_NEW];		/* obtained imbeddings with length */

#if	MS_DOS
#include	<stdlib.h>
#ifdef	__TURBOC__
extern	unsigned	_stklen = 20000;
#else
extern	unsigned	_STACK = 20000;		/* stack size */
#endif
#endif

char	*msg[9] = {
	"by ignoring symmetries\n",
	"no +- expression for orbits\n",
	"reduced expressions of the elements of Weyl group for imbeddings\n",
	"intermediate orbits and the corresponding elements of Weyl group\n",
	"only maximal imbeddings (= leading exponents) indicated by [...]\n",
	"for a given discrete series (or any other Harish-Chandra module)\n",
	"no title\n",
	"no linefeed between the levels\n",
	"\n @... : Output for an arbitrary orbit\n\t... may contains "
	};

char	*abcd[9] = {
	"SU(m,n)", "SO(2m,2n+1)", "Sp(m,n)", "SO(2m,2n)", "SO*(2m)", "Sp(m,R)",
	"SL(n,R)", "SU*(2n)    ", "SO(2m+1,2n+1)"
	};

				/* Information for orbits */
char	*each[18] = {
						/* SU(m,n) */
"+, - and pairs of Type 'aa'\n",
"	     m = #{+} + #{pairs}		n = #{-} + #{pairs}\n",

						/* SO(2m,2n+1) */
"+, -, O, pairs of Type 'aa' and 'aA'\n",
"	     m = #{+}+#{pairs}+[(#{O}+1)/2]	n = #{-}+#{pairs}+[#{O}/2]\n",

						/* Sp(m,n) */
"+, - and pairs of 'aa' and 'aA'\n",
"	     m = #{+} + #{pairs}		n = #{-} + #{pairs}\n",

						 /* SO(2m,2n) */
"+, -, even number of O and pairs of Type 'aa' and 'aA'\n",
"	     m = #{+} + #{pairs} + #{O}/2	n = #{-} + #{pairs} + #{O}/2\n",
						/* SO*(2m) */
"+, - and pairs of Type 'aa' and 'aA'\n		 where #{-} - #{pairs of type 'aa'} is even\n",
"	     m =#{+} + #{-} + 2*#{pairs}\n",

						/* Sp(n,R) */
"+, -, O, and pairs of Type 'aa' and 'aA'\n",
"	     m = #{+} + #{-} + #{O} + 2*#{pairs}\n",

						/* SL(n,R) */
"O and pairs of Type 'aA'\n",
"	     n = #{O} + 2*#{pairs}\n",

						/* SU*(2n) */
"pairs of Type 'aa'\n",
"	     n = #{pairs}\n",

"+, -, odd number of O and pairs of Type 'aa' and 'aA'\n", /* Sp(2m+1,2n+1) */
"	     m = #{+}+#{pairs}+(#{O}-1)/2	n = #{-}+#{pairs}+(#{O}-1)/2\n"
};

char	*ctr_con[4] = { "", "", CON_REV, CON_NORM };
char	*option = "EZZDSBB";

			/* Program begins from here */
void
main( )
{
	int		i, typ, p, q;
	unsigned int	f_op;
	void		get_all(), chg_def();

	if( !isatty( 0 ) ) f_out |= NO_CONIN;	/* stdin is not console */
						/* opening message */
	fprintf( stderr,
"%sUsage:  disc [< input] [> output]\n\n\t\t\tby Toshio OSHIMA (Feb. 11, 1988)\n\n Extra Options: B(Bruhat Order <- r,s,t OFF), E(Efficiency <- r,s OFF), S(Sort)\n\t\tD(Duplicated ones <- r ON), Z(Trace for Debug)", CON_CLR );

help:
	fputs( "\n\n   <<< Imbeddings of " , stderr );
	if( f_out & GIVEN ) fputs( "Harish-Chandra modules", stderr );
	else fputs( "Discrete series" , stderr );
	fputs( " into Principal Series  Ver 2.9 >>>\n\n" , stderr );
	switch( type & TYPE ){
	    case( SU21 ):
			if( type & NO_DISC ) typ = 'h';
			else typ = 'a';
			break;
	    case( SO21 ):
			typ = 'b';
			break;
	    case( Sp21 ):
			typ = 'c';
			break;
	    case( SO22 ):
			if( type & NO_DISC ) typ = 'i';
			else typ = 'd';
			break;
	    case( SO2n ):
			typ = 'e';
			break;
	    case( SpnR ):
			if( type & NO_DISC ) typ = 'g';
			else typ = 'f';
			break;
	}
	for( p = 'a'; p <= 'i'; p++ ){
	    if( p == 'g' ){
		if( f_out & GIVEN ) putc( '\n', stderr );
		else break;
	    }
	    if( p == typ ) i = 2;
	    else	   i = 0;
 	    fprintf( stderr, " %s%c:%s %s ", 
		ctr_con[i], p, ctr_con[i+1], abcd[p-'a'] );
	}
	fputs( "\n\n", stderr );
	for( p = 0, q = 1; p < 8 ; p++, q += q ){
	    if( f_out & q ) i = 2;
	    else            i = 0;
	    fprintf( stderr, " %s%c:%s Output %s",
		ctr_con[i], 'p'+p, ctr_con[i+1], msg[p] );
	}
	putc( ' ', stderr );
	f_op = (f_out >> 11)|(f_out2 << 5);
	for( p = 0, q = 1; option[p]; p++, q += q ){
	    if( f_op & q ) i = 2;
	    else	   i = 0;
 	    fprintf( stderr, "%s%c%s", 
		ctr_con[i], option[p], ctr_con[i+1]);
	}
	fputs( ": Extra Options\n", stderr );
	if( f_out & GIVEN ){
		fprintf( stderr, "%s%s%s", msg[8], each[(typ-'a')*2],
		 each[(typ-'a')*2+1] );
	}
start:					/* get numbers */
	p = q = 0;
	fputs( "\nInput 0: break, ?: help, a-", stderr );
	if( f_out & GIVEN ) putc( 'i', stderr );
	else		    putc( 'f', stderr );
	fputs( ": type, p-w: change defaults ( eg. bquB )\n\n" , stderr );

	if( f_out & GIVEN ){
		fputs( "Input orbit as ++-+ (or @....) or a-w or ?: ", stderr );
		fgets( (char *)orbo, MAX_SIZZ+2, stdin );
		if( f_out & NO_CONIN ) fputs( orbo, stderr );
		if( *orbo == '0' ) exit( 0 );
		if( *orbo == '@' ){
			for( i = 0; i < MAX_SIZZ+1; i++ ) orbo[i] = orbo[i+1];
			f_out |= CODIM;
		}
		else if( *orbo >= 'A' || *orbo == '?' ){
			chg_def( orbo );
			goto	help;
		}
		if( (i = get_orb( typ, &p, &q )) != 0 ){
			if( i == 1 ){
ill:			    fputs( "\n\nIllegal input!\007\n", stderr );
			} else if( i == 2 ){
large:			    fprintf( stderr, 
	"\n\nRank should be smaller than %d!\007\n", MAX_SIZZ );
			}
			goto help;
		}
		goto exec;
	}
	fputs( "Input number m (or a-w): ", stderr );
	fgets( (char *)orbo, MAX_SIZZ, stdin );
	if( f_out & NO_CONIN ) fputs( orbo , stderr );
	if( *orbo == '0' ) exit( 0 );
	if( *orbo >= 'A' || *orbo == '?' ){
		chg_def( orbo );
		goto	help;
	}
	sscanf( orbo, "%d\n", &p );
	if( p == 0 ) goto ill;
	if( typ < 'e' ){
		fputs( "Input number n (or a-w): ", stderr );
		fgets( (char *)orbo, MAX_SIZZ, stdin );
		if( f_out & NO_CONIN ) fputs( orbo , stderr );
		if( *orbo >= 'A' || *orbo == '?' ){
			chg_def( orbo );
			goto	help;
		}
		sscanf( orbo, "%d\n", &q );
	}
exec:
	puts( "\n" );
	if( p+q > MAX_SIZZ ) goto large;
	if( !(f_out & NO_TTL) ){
		fputs( "< Imbeddings of " , stdout );
		if( f_out & CODIM ) fputs( "a Harish-Chandra module of " , stdout );
		else		  fputs( "Discrete Series of " , stdout );
		switch( typ ){
		    case( 'a' ):
			printf( "SU(%d,%d)", p, q );
			break;
		    case( 'b' ):
			printf( "SO(%d,%d)", p*2, q*2+1);
			break;
		    case( 'c' ):
			printf( "Sp(%d,%d)", p, q );
			break;
		    case( 'd' ):
			printf( "SO(%d,%d)", p*2, q*2 );
			break;
		    case( 'e' ):
			printf( "SO*(%d)", (p+q)*2 );
			break;
		    case( 'f' ):
			printf( "Sp(%d,R)", p+q );
			break;
		    case( 'g' ):
			printf( "SL(%d,R)", p+q );
			break;
		    case( 'h' ):
			printf( "SU*(%d)", p+q );
			break;
		    case( 'i' ):
			printf( "SO(%d,%d)", p*2-1, q*2+1 );
			break;
		}
		fputs( " into Principal Series >\n", stdout );
	}
					/* main routine */
	switch( typ ){
	    case( 'a' ):
	    case( 'h' ):
		type = SU21|(type & NO_DISC);		/* SU(m,n) */
		level_end = p*q;			/* SU*(2m) */
		break;

	    case( 'b' ):
		type = (SO21+SO+atoA+plsto0+aAto00);
		level_end = p*q*2 + p;			/* SO(2p,2q+1) */
		resdif = p - q;
		break;

	    case( 'c' ):
		type = (Sp21+atoA);			/* Sp(p,q) */
		level_end = p*q*2;
		break;

	    case( 'd' ):				/* SO(2p,2q) */
	    case( 'i' ):				/* SO(2p+1,2q-1) */
		type = (SO22+aAto00)|(type & NO_DISC);
		level_end = p*q*2;
		break;

	    case( 'e' ):
		type = SO2n;
		level_end = ((p+q)*(p+q-1))/2;		/* SO*(2p) */
		break;

	    case( 'f' ):
	    case( 'g' ):
		type = (SpnR+atoA+plsto0+aAto00)|(type & NO_DISC);
		level_end = ((p+q)*(p+q+1))/2;		/* Sp(p,R) */
		break;					/* SL(n,R) */

	}
	type0 = type & TYPE;

	if( f_out & CODIM ){			/* get codimension */
		level_end = MAX_W/(p+q);
		if( level_end > (MAX_STEP-3) ) level_end = MAX_STEP-3;
		codim = -1;
		get_all( p, q );
		level_end = codim+1;
		f_out ^= CODIM;
		f_out |= HC_MOD;
	}
	get_all( p, q );
	f_out &= ~(HC_MOD);
	fflush( stdout );
	fputs( "\nCompleted!\n", stderr );
	goto	start;
}

/*
 *	Get an orbit
 */
get_orb( typ, p, q )
int	typ, *p, *q;
{
	int	ch, rank, level, i, j, np, nq;
	int	flag;	/* b_0: contains O
			   b_1: contains A,B,..
			   b_2: use for checking pairs
			   b_3: contains a,b,..
			   b_4:	contains + or -
			*/

	np = nq = flag = 0;
	level = MAX_STEP-2;
					     /* get the rank of Weyl group */
	for( i = 0; i < MAX_SIZZ; i++ ){
		if( ( ch = orbo[i] ) == '+' || ch == '-' || ch == 'O'
		   || ( ch >= 'a' && ch <= 'z' )
		   || ( ch >= 'A' && ch <= 'Z' ) ){
		continue;
		}
		rank = i;
		break;
	}
	if( i == MAX_SIZZ ) return( 2 );		/* Too large rank */
	if( !rank ) return( 1 );			/* No input */

	for( i = 0; i < rank;     ) pairo[i++] = -1;
	for( i = 0; i < rank; i++ ){		       /* Change into inner */ 
		if( ( ch = orbo[i] ) == '+' ){	       /*  format */
			flag |= 16;
			np++;
			orbo[i] = 1;
			continue;
		}
		if( ch == '-' ){
			flag |= 16;
			nq++;
			orbo[i] = 2;
			continue;
		}
		if( ch == 'O' ){
			flag |= 2;
			orbo[i] = 0;
			pairo[i] = -2;
			continue;
		}
		if( ch >= 'a' && ch <= 'z' ){
			if( pairo[i] != -1 ) continue;
			orbo[i] = level;
			for( j = i+1; j < rank; j++ ){
				if( ch == orbo[j] ){
					if( flag & 4 ) return( 1 );
					flag |= 12;
					orbo[j] = level--;
					goto skip1;
				}
				else if( ch == orbo[j] + 32 ){
					if( flag & 4 ) return( 1 );
					flag |= 5;
					orbo[j] = SHIFT + level--;
skip1:					pairo[i] = j;
					pairo[j] = i;
				}
			}
			if( !(flag & 4) ) return( 1 );	/* incorrect pair */
			else flag &= ~4;
		}
		else if( pairo[i] < 0 ) return( 1 );	/* incorrect pair */
	}

	if( !(f_out & CODIM) && (flag & ~16) ) return( 1 );

	switch( typ ){

		case( 'h' ):
			if( flag & 16 ) return( 1 );
		case( 'a' ):
			if( flag & 3 ) return( 1 );
			goto skip2;

		case( 'd' ):
		case( 'i' ):
			for( i=j=0; i < rank; i++ ){
			    if( !orbo[i] ) j++;
			}
			if ( j & 1 ){
			    if( typ == 'd' ) return( 1 ); /* SO(2p-1,2q+1) */
			} else {
			    if( typ == 'i' ) return( 1 );
			}
		case( 'b' ):
skip2:
			*q = (rank-np+nq)/2;
			*p = rank - *q;
			break;

		case( 'c' ):
			if( flag & 2 ) return( 1 );
			goto skip2;

		case( 'e' ):
			for( i=j=0; i < rank; i++ ){
			    if( (ch = orbo[i]) > 3 )
				if( ch <= SHIFT ) j++;
				else		  j--;
			}
			if( flag & 2 || (nq + (j/2)) & 1 ) return( 1 );
		case( 'f' ):
skip3:			*p = rank;
			*q = 0;
			break;

		case( 'g' ):
			if( flag & 16 ) return( 1 );
			for( i = 0; i < sizz; i++ ){
			    if( ( j = pairo[i] ) > i && orbo[j] <= SHIFT ){
				return( 1 );
			    }
			}
			goto skip3;
	}
	return( 0 );
}

/*
 *	Change default
 */
void
chg_def( pt )
char		*pt;
{
	int	p, q;

	fputs( CON_CLR , stderr );

	if( !(f_out & GIVEN) && *pt >= 'g' ) goto skip;

	switch( *pt ){
		case( 'a' ):	type = SU21;
				goto next;
		case( 'b' ):	type = SO21;
				goto next;
		case( 'c' ):	type = Sp21;
				goto next;
		case( 'd' ):	type = SO22;
				goto next;
		case( 'e' ):	type = SO2n;
				goto next;
		case( 'f' ):	type = SpnR;
				goto next;
		case( 'g' ):	type = SpnR|NO_DISC;
				goto next;
		case( 'h' ):	type = SU21|NO_DISC;
				goto next;
		case( 'i' ):	type = SO22|NO_DISC;
next:				pt++;
				break;
	}

skip:
	while( *pt >= 'p' && *pt <= 'w' ){	/* Change default */
		p = *pt++ - 'p';
		q = 1;
		while( p-- ) q += q;
		f_out ^= q;
	}
	if( !(f_out & GIVEN) ) type &= ~NO_DISC;
	for( ; ; pt++ ){
		switch( *pt ){
			case( 'B' ):	if( f_out2 & ORDER ){
					    if( f_out2 & ORIENT ){
						f_out2 &= ~(ORDER|ORIENT);
					    }
					    else f_out2 |= ORIENT;
					}
					else	f_out2 |= ORDER;
					break;
			case( 'D' ):	f_out ^= OUT_HIT;
					break;
			case( 'E' ):	f_out ^= OUT_DUP;
					break;
			case( 'S' ):	f_out ^= SORT;
					break;
			case( 'Z' ):	if( f_out & DBG1 ){
						f_out &= ~(DBG|DBG1);
					}
					else if( f_out & DBG ){
						f_out |= DBG1;
					}
					else f_out |= DBG;
					break;
			default:	if( !(f_out & 4 ) ) f_out &= ~OUT_HIT;
					return;
		}
	}
}

/*
 *	Get all imbeddings using  get_step()  for Group(pos,neg)
 *		Output to stdout according to f_out
 */
void
get_all( pos, neg )
int	pos, neg;
{
	int	i, j, k, l, m;
	void	get_err(), put_dis(), get_step(), out_data(), get_imbed();

	sizz = pos + neg;
	if( type ) siz1 = sizz+1;
	else	   siz1 = sizz;
	siz2 = 2*sizz+1;
						/* Check parameters */
	if( sizz > MAX_SIZZ || pos < 0 || neg < 0 || sizz <= 0
         || level_end > (level_max = MAX_W/sizz - 1)
	 || level_end >= SHIFT-2 ) get_err( 1 );

					/* Initialize orbo[], wo[] */
	for ( i = 0 ; i < sizz; i++ ){
		if( !(f_out & GIVEN) ){
			if( i < pos ) orbo[i] = 1;
			else	      orbo[i] = 2;
		}
		wo[i] = i+1;
		if( !(f_out & (HC_MOD|CODIM) ) ) pairo[i] = -1;
	}

	if( f_out & GIVEN ) {			/* For a given +-+- */
		get_imbed( 0 );
		return;
	}

	if( type0 == SpnR || type0 == SO2n ){		/* Sp(n,R), SO*(2n) */
		if( f_out & 33 ){
			k = 0;
			m = 1;
		}
		else{
			k = 1;
			m = 2;
		}
repeat:
		get_imbed( m );
again:
		for( i = k; i < sizz; i++ ){
		    if( orbo[i] == 1 ){
			orbo[i] = 2;
			for( j = k; j < i; ) orbo[j++] = 1;

			if( type0 == SO2n ){			/* SO*(2n) */
			    for( j = l = 0; j < sizz; j++ ){
				if( orbo[j] == 2 ) l++;
			    }
			    if ( ( l & 1 ) != 0 ) goto again;
			}

			goto repeat;
		    }
		}
		return;
	}

	for( ;; ){
		k = j = m = 0;

		if( !(f_out & 33) ){	/* Check symmetric ones to skip */

			if( type0 ){			/* SO(m,n), Sp(p,q) */
				if( pos == neg && type0 != SO21 ){
					if( orbo[0] == 1 ){
						m = 2;
						goto exec;
					}
					goto next;
				}
				goto exec;
			}					/* SU(p,q) */
			for ( k = sizz-1; j < k; j++, k-- ){
				if( orbo[j] < orbo[k] ) break;
				if( orbo[j] > orbo[k] ) goto next;
			}
			if( k > j ) m = 2;
			else	    m = 1;
			if( pos == neg ){
				for( k = 0; k+k < sizz; k++ ){
				    if( orbo[k]+orbo[sizz-k-1] != 3 ){
					if( orbo[k] == 1 ) goto next;
					else {
						m += m ;
						break;
					}
				    }
				}
			}

		}
exec:
		get_imbed( m );
next:
					/* Search the next compact orbit */
		for( i = 1 ; i < sizz ; i++ ){
			if( orbo[i-1] < orbo[i] ){
				orbo[i-1] = 2;
				orbo[i] = 1;
				j = 0;
				k = i-2;
				while( j < k ){
					if( orbo[j] < orbo[k] ){
						j++;
						k--;
					}
					else if( orbo[j] > orbo[k] ){
						orbo[j] = 1;
						orbo[k] = 2;
					}
					else if( orbo[j] == 1 ){
						j++;
					}
					else	k--;
				}
				break;
			}
		}
		if( i >= sizz ) return;
	}
}

/*
 *	get imbeddings
 */
void
get_imbed( m )
int		m;
{
	void	put_dis( ), out_data( ), get_step();

	count = dupl = 0;
	if( !(f_out & CODIM ) ){
		put_dis( m );			/* Output a compact orbit */
	}
	get_step( 0, 0, orbo, wo, pairo );
	if( !(f_out & (12|CODIM)) ) out_data();	/* Output imbeddings */
}


/*
 *	Main procedure to obtain imbeddings for a given discrete series
 */
void
get_step( level, level_v, orb, w, pair )

int		level, level_v, *pair;
unsigned char 	*orb, *w;

{
	int		i, j, k;
	int		change;	/*  0: ab --> ba, +a --> a+  etc.	*/
				/*  1: +- --> aa : a, b, c, C, d, D	*/
				/*  2: aA --> 00 : b, C			*/
				/*  3:  a --> A	 : b, c, C		*/
				/*  4:  + --> 0	 : b, C			*/
				/*  5: +- --> aA : d			*/
				/*  6: aa --> 00 : d			*/
				/*  7: a+ --> +A : d			*/
				/*  8: +a --> A+ : d			*/
				/*  9: +0 --> 0+ : d			*/
				/* 10: ab --> BA : d 			*/
				/* 11: ++ --> aA : D			*/
				/* 12: a+ --> -A : D			*/
				/* 13: +a --> A- : D			*/
				/* 14: ab --> BA : D			*/

				/* 15: 0a --> A0 : d			*/
				/* 16: a0 --> 0A : d			*/
				/* 17: aB --> bA : d			*/
				/* 18: Ab --> Ba : d,D			*/


void		get_step(), found(), get_err(), out_ch(), out_pair();

	if( f_out & DBG ){
	    putchar( '\n' );
	    k = level;
	    for( i = 0; i < level; i++ ){
		if( ( j = step[i] ) < 0 ){
			 putchar( '/' );
			k++;
			j = -j;
		}
		printf( "%x", j );
	    }
	    if( k < 16 ) putchar( '\t' );
	    if( k < 8  ) putchar( '\t' );
	    putchar( '\t' );
	    out_ch( sizz, w );
	    putchar( '\t' );
	    for( i = 0; i < sizz; i++ ){
		if( (j = orb[i]) > SHIFT ) putchar( 'A'+orb[pair[i]]-3 );
		else if( j > 2 ) putchar( 'a'+j-3 );
		else {
			if( j == 2 ) j = '-';
			else if( j == 1 ) j = '+';
			else j = 'O';
			putchar ( j );
		}
	    }
	    putchar ( '\t' );

		if( f_out & DBG1 ){
		    out_pair( pair );
		    putchar( '\t' );
		}
	}

/*
	if( level_max <= level ) get_err( 3 );
*/
	for( i = 0; i < sizz; i++ ){
		/* Prepare the next level */
		w[i+sizz] = w[i];
		orb[i+sizz] = orb[i];
	}

	for( i = 1; i < siz1; i++ ){

		if( i == sizz ){		/* b, c, C, d, D */
		    if( type & dD ){			/* d, D */
			if( w[i-2] + w[i-1] > siz2 ) break;
			if( ( j = orb[i-2] ) > SHIFT ) break;	/* (A.) */

			if( type0 == SO22 ){		/* d : SO(2m,2n)  */
			    if( !j ){
				if( (j = orb[i-1] ) > 2 && j <= SHIFT ){
					change = 15;		/* (0a) */
					goto exec;
				}
				break;				/* (0.?) */
			    }
			    if( j < 3 ){			/* (+.) */
				if( (j = orb[i-1]) == 0 ){
					change = 9;		/* (+0) */
					goto exec;
				}
				if( j < 3 && j != orb[i-2] ){
					change = 5;		/* (+-) */
					goto exec;
				}
				if( j > 2 && j <= SHIFT ){
					change = 8;		/* (+a) */
					goto exec;
				}
				break;
			    }

			    if( j > SHIFT ){		/* (A.) */
dD_Ab:				if( ( j = orb[i-1] ) > 2 && j <= SHIFT
				   && pair[i-1] < pair[i-2] ){
					change = 18;		/* (Ab) */
					goto exec;
				}
				break;
			    }
							/* (a.) */
			    if( !(j = orb[i-1]) ){
					change =  16;
					goto exec;		/* (a0) */
			    }
			    if( j < 3 ){			/* (a+) */
				change = 7;
				goto exec;
			    }
			    if( j <= SHIFT ){
				if( pair[i-1] == i-2 ){		/* (aa) */
					change = 6;
					goto exec;
				}
				change = 10;			/* (ab) */
				goto exec;
			    }
dD_aAB:			    if( pair[i-1] > pair[i-2] ){
   				change = 17;			/* (aB) */
				goto exec;
			    }
			    break;				/* (aB),(aA) */
			}
							/* D : SO*(2m) */

			if( j < 3 ){				/* (+.) */
			    if( j == orb[i-1] ){
				change = 11;			/* (++) */
				goto exec;
			    }
			    if( ( j = orb[i-1] ) > 2 && j <= SHIFT ){
				change = 13;			/* (+a) */
				goto exec;
			    }
			    break;
			}
			if( j >= SHIFT ) goto dD_Ab;	/* (A.) */
							/* (a.) */
			if( (j = orb[i-1]) < 3 ){ 		/* (a+) */
				change = 12;
				goto exec;
			}
			if( j <= SHIFT ){
				if( pair[i-1] != i-2 ){		/* (ab) */
					change = 14;
					goto exec;
				}
				break;
			}
			goto dD_aAB;
		    }
						/* b, c, C */
		    if( w[i-1] > sizz ) break;
		    if( (j = orb[i-1]) > 2  && j <= SHIFT && (type & atoA) ){				change = 3;				/* a -> A */
			goto exec;
		    }
		    if( j > 0  && j < 3  && (type & plsto0) ){
			if( type & SO ){			/* b */
			    for( k = 0, j = sizz-2; j >= 0; j-- ){
				if( orb[j] == 1 ) k++;
				else if( orb[j] == 2 ) k--;
			    }
			    if( k != resdif && k != resdif-1 ) break;
			}
			change = 4;				/* + -> 0 */
			goto exec;
		    }
		    break;
		}

						/* Reduced expression? */
		if( w[i-1] > w[i] || orb[i-1] ==  orb[i] ) continue;

		change = 0;

		if( k = pair[i], (j=pair[i-1]) < 0  ) {
				/* (+.) or (0.) */

		    if( k < 0 ){	/* (+-) or (+0) or (0+) */

			if( k + j  == -2 ) change = 1;	/* (+-) */
			else if( k == -1 ) continue;	/* (0+) */
							/* (+0) */
		    }
					/* (+a) or (+A) or (0a) or (0A).. */

		    else if( orb[i] <= SHIFT && ( k < i || j == -2 ) ){
			continue;
		    }			/* a(+a), a(0a), (0a)A, (0a)a */

					/* (+a)a, (+a)A, a(+A), a(0A) */

		}
		else {		/* (a.) or (A.) */

		     if( k < 0 ){
			if( orb[i-1] <= SHIFT ){
			    if( j < i ) goto exec;	  /* a(a+), a(a0) */
			    else if( k == -2 ) goto exec; /* (a0)A, (a0)a */
			}
			continue;	/* (a+)a, (a+)A, a(A+), a(A0) */
		    }
		    if( i == j ){	/* (aA) */
			if( type & aAto00 ) {
				change = 2;
				goto exec;
			}
			continue;
		    }
		    if( j < k ){
			if( orb[i-1] > SHIFT || orb[j] > SHIFT ) continue;
			/* a(Ab)b, a(Ab)B, ab(Ab), ab(AB), (ab)Ab, (ab)AB */

			    goto exec;
			/* a(ab)b, a(ab)B, ab(ab), ab(aB), (ab)ab, (ab)aB */
		    }
		   if( orb[i] > SHIFT || ( k > 0 && orb[k] > SHIFT ) ){
			goto exec;
		   }
		   	/* ba(aB), ba(AB), (ab)Ba, (ab)BA, b(aB)a, b(aB)A */

		   continue;
			/* ba(ab), ba(Ab), (ab)ba, (ab)bA, b(ab)a, b(ab)A */

		}

exec:
		for( j = 0; j < sizz; j++ ){	/* Prepare next pair */
			pair[j+sizz] = pair[j];
		}

		k = i + sizz-1;
		if( i == sizz ){
		    if( type & dD ){		/* type d, D */
			w[k]   = siz2 - w[i-2];
			w[k-1] = siz2 - w[i-1];
			j = 0;
			if( level ){
			    if( (j = step[level-1]) < 0 ){
				if( f_out & MAXONLY ) goto exec1;
#if	CKPQ
				if( j != 2 - sizz ) goto exec1;	/* /j(/i) */ 
#if	CKPQ2
				else if( level > 1 && step[level-2] == -i )
#endif
				    goto exec1;		/* /i/j(/i) */
#endif
				goto exec0;
			    }
			    if( j == sizz-2 ){
				j = 1;
				if( f_out & MAXONLY ) goto exec1;
				goto exec0;
			    }
#if	CKPQ
			    continue;			/* j(/i) */
#endif
			}
			if( f_out & MAXONLY ) goto exec1;
			goto exec0;
		    }
		    else{			/* type b, c, C */
			w[k] = siz2 - w[i-1];
		    }
		}
		else{
						/* permutation (i,i+1) */
		    w[k+1] = w[i-1];		/* k = i+sizz-1 */
		    w[k] = w[i];
		}

#if	CKPQ						/* Differential Op. */
		if( level ){
		    if( (j = step[level-1]) < 0 ){
			if( (f_out & MAXONLY)
			||   i+j > 1		/* /j(/i) && j<i-1  */
#if	CKPQ2						/* /i/j(/i) */
 			|| ( i+j == 1 && level > 1 && step[level-2] == -i 
			      && i != sizz )
#endif
				) goto exec1;
		    }
		    else{		      /* j(/i) && (i-j>1 || j-i>1)  */
			j = i - j;
			if( j > 1 ) continue;
			if( f_out & MAXONLY ) goto exec1;
			if( type & dD ){
			    if( i < sizz - 2 ){
				if( j < -1 ) goto exec1;
			    }
			    else if( i == sizz - 1 ) goto exec1;
			}
			else if ( j < -1 ) goto exec1;
#if	CKPQ2
			if( level > 1 && step[level-2] == i 
			  && i+j != siz2-2 ){
			    goto exec1;		      /* ij(/i)	*/
			}
#endif
		    }
		}
		else{
		    j = 0;
		    if( f_out & MAXONLY ) goto exec1;
		}
#endif	e

exec0:
		step[level] = -i;
		get_step( level+1,level_v,orb+sizz,w+sizz,pair+sizz );

exec1:							/* Integral Op. */
#if	CKPQ
#if	CKPQ2
		if( j < 1 ) goto exec2;
#endif
/*		if( j > 1 ){
			goto recover;	/ .j(i). && j<i-1 /
		}
		This part is not necessary (Never come here).
*/
#if	CKPQ2
		if( level > 1 ){
			if( step[level-2] == i && (i != sizz || type & dD) ){
				goto recover;	/* .ij(i).  */
			}
#if	CKPQ3
			if( step[level-2] == -i && i != sizz
			    && *(orbo+i-sizz-2) == *(orbo+i-sizz)
			    && *(pair+i-sizz) == -1 ){
				goto recover;	/* /iji for +-+ or -+- */
			}
#endif
		}
exec2:
#endif
#endif

		if( f_out & DBG ) printf( "%3d", change );

		switch ( change ){

		    case( 0 ):				/* ab  -->  ba */
			pair[k+1] = pair[i-1];		/* rearrange pairs */
			pair[k]   = pair[i];

			if( (orb[k] = orb[i]) > 2 ){
				pair[pair[i]+sizz] = i-1;
			}
			if( (orb[k+1] = orb[i-1]) > 2 ){
				pair[pair[i-1]+sizz] = i;
			}
			break;

		    case( 1 ):				/* (+-) --> (aa) */
			orb[k] = orb[k+1] = level_v+3;
			pair[k] = i;			/* create a new pair */
			pair[k+1] = i-1;
			break;

		    case( 2 ):				/* (aA) --> (00) */
			orb[k+1] = orb[k] = 0;
			pair[k+1] = pair[k] = -2;	/* erase a pair */
			break;

		    case( 3 ):				/* (a) --> (A) */
			orb[k] = level_v+(SHIFT+1);
			break;

		    case( 4 ):				/* (+) --> (0) */
			orb[k] = 0;
			pair[k] = -2;
			break;

		    case( 5 ):				/* (+-) --> (aA) */
		    case( 11 ):				/* (++) --> (aA) */
			orb[k-1] = level_v+3;
			orb[k] = level_v+(SHIFT+1);
			pair[k-1] = i-1;
			pair[k] = i-2;
			break;

		    case( 6 ):
		        orb[k-1] = orb[k] = 0;		/* (..) --> (00) */
			pair[k-1] = pair[k] = -2;
			break;

		    case( 7 ):				/* (a+) --> (+A) */
			orb[k-1] = orb[i-1];
case_7:			pair[k-1] = -1;
case7:
			orb[k] = orb[i-2] + SHIFT;
			pair[ (pair[k] = pair[i-2]) + sizz ] = sizz-1;
			break;

		    case( 8 ):				/* (+a) --> (A+) */
			orb[k] = orb[i-2];
case_8:			pair[k] = -1;
case8:			orb[k-1] = orb[i-1] + SHIFT;
			pair[ (pair[k-1] = pair[i-1]) + sizz ] = sizz - 2;
			break;

		    case( 9 ):				/* (+0) --> (0+) */
			orb[k] = orb[i-2];
			orb[k-1] = orb[i-1];
			pair[k] = -1;
			pair[k-1] = -2;
			break;

		    case( 10 ):				/* (ab) --> (BA) */
		    case( 14 ):
			orb[k] = orb[i-2] + SHIFT;
			orb[k-1] = orb[i-1] + SHIFT;
			pair[ (pair[k-1] = pair[i-1]) + sizz ] = sizz - 2;
			pair[ (pair[k] = pair[i-2]) + sizz ] = sizz-1;
			break;

		    case( 12 ):				/* (a+) --> (-A) */
			orb[k-1] = 3 - orb[i-1];
			goto case_7;

		    case( 13 ):				/* (+a) --> (A-) */
			orb[k] = 3 - orb[i-2];
			goto case_8;

		    case( 15 ):				/* (0a) --> (A0) */
			orb[k] = 0;
			pair[k] = -2;
			goto case8;

		    case( 16 ):				/* (a0) --> (0A) */
			orb[k-1] = 0;
			pair[k-1] = -2;
			goto case7;

		    case( 17 ):				/* (aB) --> (bA) */
			orb[k]   = level_v + (SHIFT+1);
			orb[k-1] = orb[pair[i-1]];
case17:			pair[(pair[k] = pair[i-2])+sizz] = i-1;
			pair[(pair[k-1] = pair[i-1])+sizz] = i-2;
			break;

		    case( 18 ):				/* (Ab) --> (Ba) */
			orb[k] = orb[pair[i-2]];
			orb[k-1] = level_v + (SHIFT+1);
			goto case17;
		}
		step[level] = i;

		if( level_v+1 == level_end ){	/* Reach an imbedding? */
							/* Store the length */
			w[sizz*2] = (unsigned char)(level - level_v);
			if( check_new( w+sizz ) ){	   /* A new one? */
				found( level+1, w+sizz );  /*  then output */
			}
			else if( f_out & OUT_HIT ){
				found( level+1, w+sizz );
				printf( "\t<-- Dup." );
			}
			goto recover;
		}

		if( f_out & CODIM ){	/* only output codimension */
			if( codim <= level_v ) codim = level_v;
		}
		get_step( level+1,level_v+1,orb+sizz,w+sizz,pair+sizz );
recover:
		if( i < siz1 - 1 ){	/* Recover the preparation */
#if	MS_DOS
			*((int *)(w+k)) = *((int *)(w+i-1));
			*((int *)(orb+k)) = *((int *)(orb+i-1));
#else
			w[k+1]   = w[i];
			w[k]     = w[i-1];
			orb[k+1] = orb[i];
			orb[k] = orb[i-1];
#endif
		}
	}
}

/*
 *	Check an given imbedding a new one and if it is new, it is stored.
 */
check_new( w )
unsigned char	*w;
{
	int		i, siz, comp();
	unsigned char	*ww;
	void		get_err(), out_ch();

	dupl++;
	ww = neww;
	siz = sizz+1;

	if( f_out & SORT ){
		if( bsearch( w, neww, count, sizz+1, comp ) != NULL ){
			return( NO );
		}
		goto new;
	}
						/* Is it a new imbedding? */
	for ( ww = neww + siz*(count-1) ; ww >= neww ; ww -= siz ){

#if	MS_DOS
		for( i = 0 ; i < sizz  ; i += 2 ){
			if( *((int *)(ww+i)) != *((int *)(w+i)) ) goto next;
		}
#else
		for( i = 0 ; i < sizz  ; i++ ){
			if( ww[i] != w[i] ) goto next;
		}
#endif
		return( NO );		/* The same one already exists */
next: ;
	}
new:					/* It is a new one */
	if ( MAX_NEW < count*siz ) get_err( 2 );
	for( ww = neww + siz*count, i = 0 ; i < siz ; i++ ){
		ww[i] = w[i];			/* Store it */
	}
	count++;
        if( f_out & SORT ) qsort( neww, count, 1+sizz, comp );
	return( YES );
}

/*
 *	Output an orbit to stdout
 */
void
put_dis( ff )
int	ff;
{
	int	ch, i, l, flag;

	putchar( '\n' );
	if( (f_out & 2) && !(f_out & HC_MOD) ) goto next;

	for( i = flag = 0; i < sizz; i++ ){
		if( !(l = orbo[i]) ){
			ch = 'O';
			flag = 1;
		}
		else if( l == 1 ) ch = '+';
		else if( l == 2 ) ch = '-';
		else if ( l <= SHIFT ){
			ch = ('a' + MAX_STEP - 2) - l;
			flag = 1;
		}
		else ch = ('A' + MAX_STEP - 2 + SHIFT) - l;
		putchar( ch );
	}

	putchar( '\t' );
	if( flag ) return;
next:
	for( i = 1; i < sizz; i++ ){
		if( orbo[i-1] == orbo[i] ) putchar( 'c' );
		else               	   putchar( 'n' );
	}
	switch( type0 ){
	    case( SO21 ):			/* SO(2m,2n+1)	*/
		if( orbo[sizz-1] == 1 ) fputs( "=>n", stdout );
		else			fputs( "=>c", stdout );
		break;
	    case( Sp21 ):			/* Sp(m,n)	*/
		fputs( "<=c", stdout );
		break;
	    case( SpnR ):		        /* Sp(n,R)	*/
		fputs( "<=n", stdout );
		break;
	    case( SO22 ):			/* SO(2m,2n)    */
		if( orbo[sizz-2] == orbo[sizz-1] ) fputs( "(c)", stdout );
		else				   fputs( "(n)", stdout );
		break;
	    case( SO2n ):			/* SO*(2n)	*/
		if( orbo[sizz-2] == orbo[sizz-1] ) fputs( "(n)", stdout );
		else				   fputs( "(c)", stdout );
	    	break;
	}
	if( !(f_out & 1) ){
		if( ff > 1 ) printf( "\tx%d", ff );
		else	     printf( "\t  " );
	}
}

void
out_data()
{
	char		ch1, ch2;
	int		flag, width, step, index;
	unsigned char	*ww, *we;
	void		out_ch(), out_order();
        int		comp();

	if( !level_end ) step = 1;
	else step = count;
	if( !(f_out & CODIM) ){
		printf( "  codim: %d, # imbed: %d", level_end, step );
		if( f_out & OUT_DUP ) printf( " <-- %d", dupl );
	}
	putchar( '\n' );

        if( !(f_out & SORT) && (f_out2 & ORDER) != 0  ){
		qsort( neww, count, 1+sizz, comp );
	}
	we = neww + (1+sizz)*count;
	for( step = width = index = 0 ; ; step++ ){
	    for( flag = 0, ww = neww ; ww < we ; ww += 1+sizz ){

		if( ww[sizz] != step ) continue;
		if( !(f_out & NO_LF) && !flag && step ){
			putchar( '\n' );
			width = 0;
		}
		if( (width += (sizz+2) ) > MAX_WIDTH ){
			putchar( '\n' );
			width = sizz+2;
		}
		if( step & 1 ){
			ch1 = '(';
			ch2 = ')';
			index--;
		}
		else if( step ){
			ch1 = '<';
			ch2 = '>';
			index++;
		}
		else{
			ch1 = '[';
			ch2 = ']';
			index++;
		}
		putchar( ch1 );
		out_ch( sizz, ww );
		putchar( ch2 );

		flag = 1;

	   }
	   if( !flag ){
		if( index != 1 && !(f_out & MAXONLY) && count > 1 ){
		    printf("\n\n%sMaybe Error:5 Type:%d Index:%d",
			CON_REV, type, index );
		    put_dis( 0 );
		    printf(
	"\n%sPlease report the above data to T. Oshima.\n\n", CON_NORM );
		}
		if( (f_out2 & ORDER) && !(f_out & MAXONLY) ) out_order();
		return;
	   }
	}
}

#define		MASK	0x0fff
#define		F_DONE	0x1000
#define		F_POS	0x2000
#define		F_NEG	0x4000

/*
 *	output the Bruhat order
 */
void
out_order()
{
	int		step, flag, num;
	int		*iws, *iwe, *iw1, *iw2, *iwp, *iwq;
	unsigned char	*w1, *w2, *we, *wp, *wq;
	void		get_err(), get_orient();

	we = (w2 = wp = neww) + (1+sizz)*count;
	iws = iw2 = iwp = (int *)(neww + 
		+ (((1+sizz)*count-1)/sizeof(int)+1)*sizeof(int));
	iwe = (int * )(neww + MAX_NEW);
	flag = f_out2 & ORIENT;
	printf( "\n>>>\n" );

	for( step = 0 ; wp < we ; wp += 1+sizz ){

		if( step != wp[sizz] ){
			step = wp[sizz];
			w1 = w2;
			w2 = wp;
			if( !flag ) putchar( '\n' );
		}
		num = (wp-w2)/(1+sizz) + 1;
		if( !step ){
			printf( "[%d]", num );
			if( flag ){
				*iwp++ = num;
				*iwp++ = 0;
			}
		}
		else if( !flag ){
			if( step & 1 )  printf( "(%d:", num );
			else		printf( "<%d:", num );
			for( wq = w1; wq < w2; wq += 1+sizz ){
			    if( order( wp, wq ) ){
				printf( " %d", (wq-w1)/(1+sizz) + 1 );
			    }
			}
			if( step & 1 )  putchar( ')' );
			else		putchar( '>' );
		}
		else {
			*iwp++ = num;
			for( wq = w1; wq < w2; wq += 1+sizz ){
			    if( order( wp, wq ) ){
				*iwp++ = (wq-w1)/(1+sizz) + 1;
				if( iwp > iwe ) get_err( 3 );
			    }
			}
			*iwp++ = 0;
		}
	}
	if( !flag ) return;
	*iwp++ = 0;
	for( step = -1, iwp = iws ; ; ){
		if( (num = *iwp++) == 1 ){
			iw1 = iw2;
			iw2 = iwp-1;
			step++;
			if( step ) putchar( '\n' );
		}
		else if( num == 0 ) return;
		if( !step ){
			iwp++;
			continue;
		}
		if( step == 1 ){
			if( !*iwp++ ) goto err;
			*iwp = -*iwp;
			iwp++;
			if( *iwp++ ){
err:			    fprintf( stderr, "\nMaybe Error 6: 2 points\n" );
			}
			printf( "(%d:%+d%+d)", num, *(iwp-3), *(iwp-2) );
			continue;
		}
		if( step & 1 )  printf( "(%d:", num );
		else		printf( "<%d:", num );
		*iwp |= F_POS;
		get_orient( iw1, iw2, iwp-1 );
		while( *iwp != 0 ){
			printf( "%+d", *iwp++ );
		}
		iwp++;
		if( step & 1 )  putchar( ')' );
		else		putchar( '>' );
	}
}

/*
 *	Define an oriented ordering
 */
void
get_orient( iw1, iw2, iw3 )
int	*iw1, *iw2, *iw3;
{
	int	i, count, flag, end, m1, k, *iwq;

	for( end = 1; iw3[end] != 0; end++ );

loop:	for( i = 1, count = 0; i < end; i++ ){
		if( !(iw3[i] & (F_POS|F_NEG))||(iw3[i] & F_DONE) ) continue;
		iw3[i] |= F_DONE;
		m1 = iw3[i] & MASK;
		flag = iw3[i] & (F_POS|F_NEG);
		count++;
		for( iwq = iw1; *iwq != m1 && iwq < iw2; ){ /* search m1-th */
			while( *iwq++ != 0 );
		}
		while( *(++iwq) != 0 ){
			k = get_bry( iw1, iw2, iw3, m1, *iwq, end );
			if( k == MASK ) iw3[i] |= (F_POS|F_NEG);
			if( k < 0 ){
				k = -k;
				if( flag == F_NEG ) 	iw3[k] |= F_POS;
				else			iw3[k] |= F_NEG;
			}
			else{
				if( flag == F_POS ) 	iw3[k] |= F_POS;
				else			iw3[k] |= F_NEG;
			}
		}
	}
	if( count != 0 ) goto loop;
	for( i = 1; i < end; i++ ){
		k = iw3[i] & (F_POS|F_NEG);
		if( k == F_POS )	iw3[i] &= MASK;
		else if( k == F_NEG )	iw3[i] = -(iw3[i] & MASK);
		else			iw3[i] = (iw3[i] & MASK)+10000;
	}
}

/*
 *
 */
int
get_bry( iw1, iw2, iw3, m1, m0, end )
int	*iw1, *iw2, *iw3;
int	m1, m0, end;
{
	int	num, count, i, find, *iwp, *iwq;

	count = 0;
	num = *iw1;

	for( iwp = iw1+1; iwp < iw2; iwp++ ){
		if( !*iwp ){
			iwp++;
			num = *iwp;
			continue;
		}
		if( num == m1 || ( *iwp != m0 && *iwp != -m0 ) ) continue;
		for( i = 1; i < end && (iw3[i] & MASK) != num; i++ );
		if( i >= end ) continue;
		count++;
		if( *iwp == m0 )  find = -i;
		else		  find = i;
	}
	return( (count==1)? find: MASK);
}

/*
 *	Is difference a reflection?
 */
int
order( wp, wq )
unsigned char	*wp, *wq;
{
	int	i, d1, d2, tp, num;

	for( i = num = 0; i < sizz; i++ ){
		if( wp[i] != wq[i] ){
			if( num++ == 0 ) d1 = i;
			else if( num == 2 ) d2 = i;
			else return( 0 );
		}
	}
	if( !num ) return( -1 );
	if( num == 1 ) return( 1 );
	if( (wp[d1] == wq[d2] && wp[d2] == wq[d1]) ||
	    (wp[d1] + wq[d2] == wp[d2] + wq[d1] ) ) return( 1 );
	return( 0 );
}

/*
 *	Sort elements of Weyl group
 */
int
comp( w1, w2 )
unsigned char	*w1, *w2;
{
	int	i, dif;

	if( (dif = w1[sizz] - w2[sizz]) != 0 ) return( dif );
        for( i = 0; i < sizz; i++ ){
		if( (dif = w1[i] - w2[i]) != 0 ) return( dif );
	}
	return ( 0 );
}

/*
 *	Output one imbedding to stdout according to f_out
 */
void
found( level, w )
int		level;
unsigned char	*w;
{
	int	i, j, k, l, m, ch;
	void	out_ch(), get_err(), out_pair();

	k = sizz*level;
	if( count == 1 ){
		for( i = 0; i < sizz; i++ ) pairz[i] = pairo[k+i];
	}
	else if( count ) {
		for( i = 0; i < sizz; i++ ){
			if( pairz[i] != pairo[k+i] ){
				count = 0;
				f_out = 12|DBG|DBG1;
				printf( 
				  "\n\n%sInternal Error:4 Type:%d\n",
				   CON_REV, type );
				found( level, w );
				printf( CON_NORM );
				get_err( 4 );
			}
		}
	}

	if( !(f_out & 12) ) return;	/* Output after sorting */

	putchar ( '\n' );

	if( w[sizz] ) putchar( '(' );
	else	      putchar( '[' );

	out_ch( sizz, w );		/* Output an imbedding */

	if( w[sizz] ) putchar( ')' );
	else	      putchar( ']' );
	putchar( ' ' );

	if( !(f_out & 4 ) ) goto next;

	for ( i = 0; i < level ; i++ ){
		if( (j = step[i] ) < 0 ){
			j = -j;
			putchar( '/' );
		}
		if( j <= 9 ) j += '0';
		else	    j += 'a'-10;
		putchar( j );   /* with a reduced expression */
	}

next:
	if( !(f_out & ALLOUT) ) return;		/* Output total data */

	putchar( '\n' );

	for( i = 0; i < MAX_STEP; ) orbc[i++] = 0;
	for( m = 'a', i = 0; i <= k; i += sizz ){

		out_ch( sizz, wo+i );
		putchar( ' ' );
		for( j = i; j < sizz+i; j++ ){
			if( (l = orbo[j]) < 3 ){
			    if( l == 0 )	ch = 'O';
			    else if( l == 1 )	ch = '+';
			    else		ch = '-';
			}
			else if( ( ch = pairo[j]) > j-i ){
			    if( !(ch = orbc[l]) ) orbc[l] = ch = m++;
			}
			else if( l <= SHIFT ) ch = orbc[l];						else ch = orbc[orbo[i+ch]]-32;
			putchar( ch );
		}

		if( (f_out & (DBG1|DBG))  == (DBG1|DBG) ){
			putchar( ' ' );
			out_pair( pairo + i );
		}
		if( i < k ){
			if( f_out & NO_LF ) putchar( ' ' );
			else		    putchar( '\n' );
		}
	}
}

void
out_ch( len, w )
int		len;
unsigned char	*w;
{
	while( len-- > 0 ){
		if( *w < 10 ) putchar( (*w++) + '0' );
		else	      putchar( (*w++) + ('a'-10) );
	}
}

void
out_pair( pair )
int	*pair;
{
	int	i, j;

	for( i = 0; i < sizz; i++ ){
		if( (j = pair[i]) >= 0 ){
			if( j < 9 )	putchar( '1'+j );
			else		putchar( ('a'-9) + j );
		}
		else if( j == -1 )	putchar( '*' );
		else			putchar( 'O'+j+2 );
	}
}

/*
 *	Some error occurred!
 */
void
get_err( num )
int		num;
{

	if( num < 4 ) fputs( "Error occurred!\n", stderr );
	switch( num ){

	    case( 1 ):
		fputs( "Too large number!\n", stderr );
		break;

	    case( 2 ):
		fputs( "Too many imbeddings!\n", stderr );
		break;

	    case( 3 ):
		fputs( "Too complicated!\n", stderr );
		break;

	    case( 4 ):
		printf( "\nPlease report the above data to T. Oshima.\n" );
		break;
	}

	exit( 1 );
}
